summaryrefslogtreecommitdiff
path: root/t/parallel-tests-dry-run-2.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-06-24 10:36:15 +0200
committerStefano Lattarini <stefano.lattarini@gmail.com>2012-06-25 10:29:43 +0200
commitc2a52bf0e8e87b8f347ca22b9ab2da7613bc4336 (patch)
tree1e2115c0d24da906daa64cc84d853e538129574f /t/parallel-tests-dry-run-2.sh
parentaa630a928a586fd8dc8a087337c3462d7f4fd1c6 (diff)
downloadautomake-c2a52bf0e8e87b8f347ca22b9ab2da7613bc4336.tar.gz
tests: simpler workaround for shells losing the exit status in exit trap
Now that we can assume our tests are run by a decent POSIX shell, we can simplify our workaround aimed at having the exit status propagated correctly to the code in the exit trap. Unfortunately, we cannot dispense with such a workaround altogether, because it's still required by some shells we need to support (at least Solaris 10 /bin/ksh and /usr/xpg4/bin/sh). For more information about the need of that workaround, see the entry about 'trap' in the section "Limitations of Shell Builtins" in the Autoconf manual: <http://www.gnu.org/software/autoconf/manual/autoconf.html#trap> The new workaround has been tested successfully with the following shells: - Bash 4.1 - Bash 3.2 - Bash 3.0 - Bash 2.05b - dash 0.5.5.1 - dash 0.5.2 - AT&T Ksh 93u (from official Debian package) - MirBSD Korn Shell 40.2 (from official Debian package) - Solaris 9, 10 and 11 /bin/ksh - Solaris 9, 10 and 11 /usr/xpg4/bin/sh - NetBSD 5.1 /bin/sh - NetBSD 5.1 /bin/ksh * t/ax/test-init.sh (Exit): Rename ... (_am_exit): ... like this. (exit): New alias for '_am_exit'. We cannot simply redefine 'exit' as a shell function, because some shells (dash 0.5.5.1, Solaris 10 /bin/ksh and /usr/xpg4/bin/sh) do not allow it. (_am_exit, trap): Add extra escaping for 'exit' calls, to ensure we really invoke the 'exit' builtin and not our alias with the same name. * configure.ac: Check that the shell selected to run our testsuite supports aliases named like shell builtins. * t/REAMDE: Adjust. * All tests: Adjust, by simply using 'exit' instead of 'Exit'. * t/self-check-explicit-skips.sh: Adjust: the first usage of 'exit' after it has been redefined as an alias must be on a new line w.r.t. that where the alias is defined, in order for the redefinition to be honored. * syntax-checks.mk (sc_tests_Exit_not_exit): Delete. (sc_tests_exit_not_Exit): New. (syntax_check_rules): Adjust. (sc_tests_automake_fails): Simplify the recipe a little. * Several tests: Remove now useless spurious quoting once required to placate the 'sc_tests_Exit_not_exit' maintainer check. * gen-testsuite-part: Likewise. Also, avoid uses of 'Exit' in the generated scripts. Signed-off-by: Stefano Lattarini <stefano.lattarini@gmail.com>
Diffstat (limited to 't/parallel-tests-dry-run-2.sh')
-rwxr-xr-xt/parallel-tests-dry-run-2.sh22
1 files changed, 10 insertions, 12 deletions
diff --git a/t/parallel-tests-dry-run-2.sh b/t/parallel-tests-dry-run-2.sh
index 20ccb5dc4..0bd6523a0 100755
--- a/t/parallel-tests-dry-run-2.sh
+++ b/t/parallel-tests-dry-run-2.sh
@@ -17,7 +17,7 @@
# Check parallel-tests interactions with "make -n".
# See also sister test 'parallel-tests-dry-run-1.test'.
-. ./defs || Exit 1
+. ./defs || exit 1
cat >> configure.ac << 'END'
AC_OUTPUT
@@ -37,11 +37,11 @@ $AUTOCONF
make_n_ ()
{
st=0
- $MAKE -n "$@" >output 2>&1 || { cat output; ls -l; Exit 1; }
+ $MAKE -n "$@" >output 2>&1 || { cat output; ls -l; exit 1; }
cat output
# Look out for possible errors from common tools used by recipes.
- $EGREP -i ' (exist|permission|denied|no .*(such|file))' output && Exit 1
- $EGREP '(mv|cp|rm|cat|grep|sed|awk): ' output && Exit 1
+ $EGREP -i ' (exist|permission|denied|no .*(such|file))' output && exit 1
+ $EGREP '(mv|cp|rm|cat|grep|sed|awk): ' output && exit 1
:
}
@@ -57,11 +57,10 @@ for target in check recheck test-suite.log; do
test ! -f test-suite.log
done
-# Creative quoting below to please maintainer-check.
-echo exit '0' > foo.test
-echo exit '1' > bar.test
+echo 'exit 0' > foo.test
+echo 'exit 1' > bar.test
-$MAKE check && Exit 1
+$MAKE check && exit 1
chmod a-w .
@@ -71,17 +70,16 @@ test -f foo.trs
test -f foo.log
test -f bar.trs
-# Creative quoting below to please maintainer-check.
cat > foo.test <<END
echo this is bad
exit 1
END
-echo exit '0' > bar.test
+echo 'exit 0' > bar.test
for target in check recheck test-suite.log; do
make_n_ $target
grep '^:test-result: *FAIL' bar.trs
- grep 'this is bad' foo.log test-suite.log && Exit 1
+ grep 'this is bad' foo.log test-suite.log && exit 1
: For shells with busted 'set -e'.
done
@@ -92,7 +90,7 @@ else
for target in check recheck test-suite.log; do
make_n_ $target
for f in $files; do
- test -f $f && test ! -r $f || Exit 1
+ test -f $f && test ! -r $f || exit 1
done
done
fi